package br.usp.ime.mac499.xba.ast;

import br.usp.ime.mac499.xba.parser.Token;
import br.usp.ime.mac499.xba.parser.XBAParser;

/**
 * Mensagens binárias da forma "e_1 seletor: e2" são parseadas para nós desse tipo.
 * Mensagens contendo operadores ("e_1 + e_2") também são parseadas para esse tipo de nó, uma 
 * vez que são tratadas como se fossem mensagens binárias cujo seletor é o símbolo(s) do operador. 
 * @author stagni
 *
 */
public class ASTBinaryMessage extends SimpleNode {
	private Token selectorToken;
	public ASTBinaryMessage(XBAParser p, int i) {
		super(p, i);
	}
	public ASTBinaryMessage(int i) {
		super(i);
	}
	
	public Token selectorToken() {
		return selectorToken;
	}	
	
	public String selector() {
		return ASTUtils.selector2name(selectorToken.image);
	}
	public void setSelectorToken(Token selectorToken) {
		this.selectorToken = selectorToken;
	}
	
	public Node receiver() {
		return jjtGetChild(0);
	}
	
	public Node argument() {
		return jjtGetChild(1);
	}
}
