package br.usp.ime.mac499.xba.ast;

import java.util.Arrays;

import br.usp.ime.mac499.xba.parser.XBAParser;

/**
 * Representa um bloco de código, uma sequência de comandos. Blocos são definidos na gramática como 
 * 
 * @author stagni
 *
 */
public class ASTBlock extends SimpleNode {
	public ASTBlock(XBAParser p, int i) {
		super(p, i);
	}

	public ASTBlock(int i) {
		super(i);
	}
	
	/**
	 * @return expressões do bloco
	 */
	public Iterable<Node> expressions() {
		return Arrays.asList(children);
	}
	
	/**
	 * A última expressão de um bloco é importante, pois ela define o valor do bloco como expressão.
	 * @return A última expressão desse bloco.
	 */
	public Node last() {
		return jjtGetChild(jjtGetNumChildren() - 1);
	}
}