package br.usp.ime.mac499.xba.ast;

import java.util.ArrayList;
import java.util.List;

import br.usp.ime.mac499.xba.parser.Token;
import br.usp.ime.mac499.xba.parser.XBAParser;

/**
 * Nó gerado ao parsear uma classe. Possui informações de campos, métodos, exports e informações
 * dos construtores
 * @author stagni
 *
 */
public class ASTClass extends ASTMethodDefinition 
/*TODO: fazer uma superclasse em comum para ASTMethodDefinition e ASTCLass. Fazer a herança dessa forma, 
 * não faz tanto sentido */
{
	Token name;
	List<ASTExportStatement> exports = new ArrayList<ASTExportStatement>();
	List<ASTFieldDefinition> fields = new ArrayList<ASTFieldDefinition>();
	List<ASTMethodDefinition> methods = new ArrayList<ASTMethodDefinition>();
	
	
	public ASTClass(XBAParser p, int i) {
		super(p, i);
	}
	public ASTClass(int i) {
		super(i);
	}
	
	public void setName(Token name) {
		this.name = name;
	}
	
	public String name() {
		return name.image;
	}
	
	@Override
	public String selectorsDescriptor() {
		if (super.numberOfParameters() == 0) return "new:";
		return "new-" + super.selectorsDescriptor();
	}
	
	@Override
	public String selector(int i) {
		if (super.numberOfParameters() == 0) return "new";
		return super.selector(i);
		
	}
	
	@Override 
	public String parameter(int i) {
		if (super.numberOfParameters() == 0) return "$hack";
		return super.parameter(i);
	}
	
	@Override
	public int numberOfParameters() {
		if (super.numberOfParameters() == 0) return 1;
		return super.numberOfParameters();
	}
	
	
	@Override
	public void jjtAddChild(Node n, int i) {
		super.jjtAddChild(n, i);
		if (n instanceof ASTExportStatement) exports.add((ASTExportStatement)n);
		if (n instanceof ASTFieldDefinition) fields.add((ASTFieldDefinition)n);
		if (n instanceof ASTMethodDefinition) methods.add((ASTMethodDefinition)n);
	}
	
	public boolean hasInitMethod() {
		for (ASTMethodDefinition method : methods) {
			if (method.numberOfParameters() == 1 && method.selector(0).equals("init")
					&& method.parameter(0) == ASTMethodDefinition.unitParameter)
				return true;
		}
		return false;
	}
	
	
	public List<ASTMethodDefinition> methods() {
		return methods;
	}
	
	public List<ASTFieldDefinition> fields() {
		return fields;
	}
	
	public List<ASTExportStatement> exports() {
		return exports;
	}
	
	
}
