package br.usp.ime.mac499.xba.ast;

import br.usp.ime.mac499.xba.parser.Token;
import br.usp.ime.mac499.xba.parser.XBAParser;

/**
 * Representa um identificador da linguagem. Quase todos os identificadores que aparecem 
 * no programa são parseados para esse nó. Excessões incluem parâmetros de métodos e de
 * construtores.
 * @author stagni
 *
 */
public class ASTIdentifier extends SimpleNode {
	private Token idToken;
	public ASTIdentifier(XBAParser p, int i) {
		super(p, i);
	}

	public ASTIdentifier(int i) {
		super(i);
	}
	
	public Token token() {
		return idToken;
	}
	
	public String name() {
		return idToken.image;
	}
	
	
	public void setIDToken(Token idToken) {
		this.idToken = idToken;
	}
	

}
