package br.usp.ime.mac499.xba.ast;

import java.util.ArrayList;
import java.util.List;

import br.usp.ime.mac499.xba.parser.Token;
import br.usp.ime.mac499.xba.parser.XBAParser;

/**
 * Nó gerado a partir da definição de cada método da classe
 * @author stagni
 *
 */
public class ASTMethodDefinition extends SimpleNode  {
	
	List<SelectorXParameter> selsxparams = new ArrayList<SelectorXParameter>();
	String methodName = "";
	public ASTMethodDefinition(XBAParser p, int i) {
		super(p, i);
	}
	public ASTMethodDefinition(int i) {
		super(i);
	}
	
	public Node body() {
		return jjtGetChild(0);
	}
	
	public int numberOfParameters() {
		return selsxparams.size();
	}
	
	public void addSelector(Token selectorName, Token parameter) {
		selsxparams.add(new SelectorXParameter(selectorName, parameter));
		methodName += selectorName;
	}
	
	public void addUnarySelector(Token selectorName) {
		selsxparams.add(new SelectorXParameter(selectorName, unitToken));
		methodName += selectorName;
	}
	
	public String methodName() {
		return methodName;
	}
	public String parameter(int i) {
		if (selsxparams.get(i).parameter == unitToken)
			return unitParameter;
		return selsxparams.get(i).parameter.image;
	}
	
	public String selector(int i) {
		return ASTUtils.selector2name(selsxparams.get(i).selector.image);
	}
	
	public String selectorsDescriptor() {
		String ret = "";
		for (int i = 0; i < numberOfParameters(); i++) 
			ret += selector(i) + ":";
		return ret;
	}

	public static final Token unitToken = new Token();
	public static final String unitParameter = new String("!");
	
	class SelectorXParameter {
		Token selector;
		Token parameter;
		public SelectorXParameter(Token selector, Token parameter) {
			this.selector = selector;
			this.parameter = parameter;
		}
	}
	
}
