package br.usp.ime.mac499.xba.codegen;

import br.usp.ime.mac499.xba.types.Type;

/**
 * Representa uma variável (um nome) que pode estar associado 
 * a um field, um local var, etc etc
 * 
 * @author stagni
 *
 */
public abstract class BindedIdentifier {
	public final Type type;
	public BindedIdentifier(Type type) {
		this.type = type;
	}
	/**
	 * Faz chamadas que geram o código responsável por colocar 
	 * na stack o valor contido nessa varíavel.
	 * 
	 * @param codeGen XBACodeGen usado para gerar o código correspondente
	 */
	public abstract void generateLoad(XBACodeGen codeGen);
	
	/**
	 * Faz chamadas que geram o código responsável por armazenar
	 * na varíavel 
	 * @param codeGen
	 */
	public abstract void generateStore(XBACodeGen codeGen);
		
}
