package br.usp.ime.mac499.xba.codegen;

import java.io.FileOutputStream;
import java.io.IOException;

import br.usp.ime.mac499.xba.ast.ASTModule;
import br.usp.ime.mac499.xba.parser.ParseException;
import br.usp.ime.mac499.xba.parser.XBAFullParser;

/**
 * Wrapper para XBACodeGen
 * @author stagni
 *
 */
public class XBAClassCompiler {
	XBACodeGen codeGen;
	
	public XBAClassCompiler() {
		codeGen = new XBACodeGen();
	}
	
	public void compile(String inFileName, String outFileName) throws IOException, ParseException {
		XBAFullParser xbaFullParser = new XBAFullParser(inFileName);
		ASTModule node = xbaFullParser.XBAModule();
		
		byte classBytes[] = codeGen.generateCode(node);
		FileOutputStream fos = new FileOutputStream(outFileName);
		fos.write(classBytes);
		fos.close();
	}
}
