package br.usp.ime.mac499.xba.runtime;

/**
 * Executável que efetivamente executa um programa XBA válido. Carrega a classe, 
 * verifica que é válida e chama o construtor.
 * USO: java br.usp.ime.mac499.xba.runtime.Launcher NOME_DA_CLASSE_XBA
 * @author stagni
 *
 */
public class Launcher extends ClassLoader {
	public static void main(String[] args) throws Throwable {
		Launcher launcher = new Launcher();
		if (args.length < 1) { 
			System.err.println("Expected classname");
			return;
		}
		
		Class<XBAObject> entryClass = launcher.loadXBAClass(args[0]);
		if (args.length == 1)
			launcher.launchWithoutArgs(entryClass);
		else { // TODO
			throw new RuntimeException("Rodar com argumentos ainda não foi implementado: falta fazer typechecking do construtor da classe com as strings passadas por parametro"); 
			//launcher.launchWithArgs(entryClass, stringCast(args));
		}
	}
	
	public void launchWithoutArgs(Class<XBAObject> xbaClass) throws Throwable {
		XBAFunction constructor = XBAObject.constructorOf(xbaClass);
		constructor.apply(XBAUnit.instance);
	}
	
	public void launchWithArgs(Class<XBAObject> xbaClass, XBAObject[] args) throws Throwable {
		XBAFunction constructor = XBAObject.constructorOf(xbaClass);		
		constructor.applyArgs(args); 
	}
	
	public static XBAObject[] stringCast(String[] args) {
		XBAObject[] ret = new XBAObject[args.length - 1];
		for (int i = 1; i < args.length; i++) {
			ret[i-1] = new XBAString(args[i]);
		}
		return ret;
	}
	
	
	@SuppressWarnings("unchecked")
	public Class<XBAObject> loadXBAClass(String className) throws ClassNotFoundException {
		// FIXME: Checar se é uma classe XBA válida
		Class<XBAObject> classz = (Class<XBAObject>)loadClass(className, true);
		Class.forName(classz.getName(), true, this); // Forçando inicialização da classe (inclui execução de static{}) 
		return classz;
		
	}
	
}
