package br.usp.ime.mac499.xba.runtime;

import java.lang.invoke.CallSite;
import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodHandles.Lookup;
import java.lang.invoke.MethodType;
import java.lang.invoke.MutableCallSite;

import br.usp.ime.mac499.xba.runtime.XBAObject.MessageNotUnderstood;



public class XBACallSite extends MutableCallSite {
	private final String selector; 
	private final Lookup lookup;
	
	public XBACallSite(String selector, Lookup lookup) {
		super(XBAObject.rraRawType); 
		this.selector = selector;
		this.lookup = lookup;
	}

	public static CallSite bootstrap(Lookup lookup, String selector, MethodType methodType) {
		XBACallSite callSite = new XBACallSite(selector, lookup);
		MethodHandle binded = oneArgCallHandler.bindTo(callSite);
		callSite.setTarget(binded);
		return callSite;
	}
	
	public XBAObject oneArgCallHandler(XBAObject receiver, XBAObject argument) {
		try {
			XBAFunction function = receiver.method(selector, lookup);
			return function.apply(argument);
		} catch (MessageNotUnderstood e) {
			throw e;
		} catch (Throwable e) {
			e.printStackTrace();
		}
		return null;
	}
	
	private static MethodHandle oneArgCallHandler;
	static {
		MethodHandles.Lookup lookup = MethodHandles.lookup();
		try {
			oneArgCallHandler = lookup.findVirtual(XBACallSite.class, "oneArgCallHandler", XBAObject.rraRawType);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
	}
}

