package br.usp.ime.mac499.xba.runtime;

import br.usp.ime.mac499.xba.transformer.XBAClass;
import br.usp.ime.mac499.xba.transformer.XBAMethod;

@XBAClass(name = "XBAInteger")
public class XBAInteger extends XBAObject {
	public final int value;
	
	public XBAInteger(int value) {
		this.value = value; 
	} 
	
	@XBAMethod(selectors = { "new:" })
	public static XBAObject constructor(XBAObject unit) {
		return new XBAInteger(0);
	}
	
	@XBAMethod(selectors = { "+" })
	public XBAObject add(XBAObject that) {
		return new XBAInteger(this.value + ((XBAInteger)that).value);
	}
	
	@XBAMethod(selectors = { "-" })
	public XBAObject sub(XBAObject that) {
		return new XBAInteger(this.value - ((XBAInteger)that).value);
	}
	
	@XBAMethod(selectors = { "*" })
	public XBAObject mult(XBAObject that) {
		return new XBAInteger(this.value * ((XBAInteger)that).value);
	}
	
	@XBAMethod(selectors = { "/" })
	public XBAObject div(XBAObject that) {
		return new XBAInteger(this.value / ((XBAInteger)that).value);
	}
	
	@XBAMethod(selectors = { "%" })
	public XBAObject rem(XBAObject that) {
		return new XBAInteger(this.value % ((XBAInteger)that).value);
	}
	
	@XBAMethod(selectors = { "to-string" })
	public XBAObject toString(XBAObject unit) {
		return new XBAString(Integer.toString(this.value)); 
	}
	
	
	public XBAObject geq(XBAObject that) {
		return XBABool.fromBool(this.value >= ((XBAInteger)that).value);
	}
	
	public XBAObject leq(XBAObject that) {
		return XBABool.fromBool(this.value <= ((XBAInteger)that).value);		
	}
	
	public XBAObject gt(XBAObject that) {
		return XBABool.fromBool(this.value > ((XBAInteger)that).value);
	}
	
	public XBAObject lt(XBAObject that) {
		return XBABool.fromBool(this.value < ((XBAInteger)that).value); 
	} 
	
	@XBAMethod(selectors = { "=" })
	public XBAObject eq(XBAObject that) {
		return XBABool.fromBool(this.value == ((XBAInteger)that).value);
	}
	
	public XBAObject neq(XBAObject that) {
		return XBABool.fromBool(this.value != ((XBAInteger)that).value);
	}
	
	
	
}
