package br.usp.ime.mac499.xba.runtime;

import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodHandles.Lookup;
import java.lang.invoke.MethodType;
import java.util.Arrays;


public class XBAObject {
	public XBAObject() { 
	}
	
	public XBAFunction method(String firstSelector) {
		return method(firstSelector, MethodHandles.lookup());
	}
	
	public XBAFunction method(String firstSelector, Lookup lookup) {
		XBAFunction function = null;
		try {
			MethodHandle mh = lookup.findStaticGetter(this.getClass(), firstSelector, XBAFunction.class);
			function = (XBAFunction) mh.invokeExact();
			function = (XBAFunction)function.apply(this);
		} catch (NoSuchFieldException e) {
			throw new MessageNotUnderstood(this.getClass(), firstSelector);
		} catch (Throwable e) {
			e.printStackTrace(); // SHOULD NEVER HAPPEN
		}
		return function;
	}
	
	
	/* A partir daqui um monte de métodos estáticos auxiliares */
	public static XBAFunction constructorOf(Class<XBAObject> classz) {
		try {
			MethodHandle mh = MethodHandles.lookup().findStaticGetter(classz, "$constructor", XBAFunction.class);
			XBAFunction ret =  (XBAFunction) mh.invokeExact();
			//System.out.println("O construtor da classe " + classz.getName() + " que peguei tem sel = " + Arrays.toString(ret.selectors));
			return ret;
		} catch (NoSuchFieldException | IllegalAccessException e) {
			e.printStackTrace();
		} catch (Throwable e) {
			e.printStackTrace();
		}
		return null;//FIXME
	}
	
	public static XBAObject defaultInstanceOf(Class<XBAObject> classz, String instance) {
		try {
			MethodHandle mh = MethodHandles.lookup().findStaticGetter(classz, "$$" + instance, XBAObject.class);
			return (XBAObject) mh.invokeExact();
		} catch (NoSuchFieldException | IllegalAccessException e) {
			e.printStackTrace();
		} catch (Throwable e) {
			e.printStackTrace();
		}
		throw new RuntimeException("NO FIELD");
	}
	
	
	public static class MessageNotUnderstood extends RuntimeException {
		private static final long serialVersionUID = 2729239965781301610L;
		public MessageNotUnderstood(Class<?> classz, String selector) {
			super("Message: " + selector + " not understood in class " + classz); 
		}
	}
	
		
	public static MethodType rraType(int numberOfArguments) {
		return rraType(numberOfArguments, XBAObject.class);
	}
	
	public static MethodType rraType(int numberOfArguments, Class<XBAObject> argType) {
		Class<?>[] args = new Class<?>[numberOfArguments];
		Arrays.fill(args, argType);
		return MethodType.methodType(XBAObject.class, args);
	}
	
	
	
	public static MethodType rraType = MethodType.methodType(XBAObject.class, XBAObject.class);
	public static MethodType rraRawType = MethodType.methodType(XBAObject.class, XBAObject.class, XBAObject.class);
}