package br.usp.ime.mac499.xba.types;

import java.io.PrintStream;
import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodType;
import java.util.HashMap;
import java.util.Map;

import com.sun.xml.internal.messaging.saaj.util.ByteOutputStream;

import br.usp.ime.mac499.xba.types.Type.Arrow;

public class TypeSerializer  {
	protected int nextId = 0;
	protected Map<Type, Integer> type2id = new HashMap<Type, Integer>();
	
	// TODO: colocar em classe a parte
	public static final char REGISTERED = 'A';
	public static final char OBJECT = 'O';
	public static final char OPEN = 'O';
	public static final char CLOSED = 'C';
	public static final char VARIABLE = 'V';
	public static final char REF = 'R';
	public static final char END = ';';
	
	public void registerType(Type t) {
		type2id.put(t, nextId++);
	}
	
	public String serializeToString(Type type) {
		ByteOutputStream baos = new ByteOutputStream();
		PrintStream stream = new PrintStream(baos);
		serialize(type, stream);
		return baos.toString();
	}
	
	// Visitor
	public void serialize(Type type, PrintStream stream) {
		if (type2id.containsKey(type)) {
			stream.append(REGISTERED);
			stream.append(type2id.get(type).toString()); stream.append(END);
			stream.append(END);
			return;
		}
		registerType(type);
		try {
			
			MethodType mtype = MethodType.methodType(void.class, type.getClass(), PrintStream.class);
			MethodHandle mh = MethodHandles.lookup().findVirtual(this.getClass(), "serialize", mtype);		
			mh.bindTo(this).invokeWithArguments(type, stream);
			return;
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (Throwable e) {
			e.printStackTrace();
		}
		throw new RuntimeException("VISITOR FAIL");
	}
	
	public void serialize(ObjectType type, PrintStream stream) {
		stream.append(OBJECT);
		stream.append(type2id.get(type).toString()); stream.append(END);
		if (type.isClosed()) stream.append(CLOSED);
		else stream.append(OPEN);
		
		
		
		for (String selector : type.selectors()) {
			Arrow arrow = type.get(selector);
			serialize(arrow.from, stream);
			stream.append(selector + END);
			serialize(arrow.to, stream);
		} stream.append(END);
		stream.append(END);
	}
	
	public void serialize(TypeVariable type, PrintStream stream) {
		stream.append(VARIABLE);
		stream.append(type2id.get(type).toString()); stream.append(END);
		stream.append(END);
	}
	
	public void serialize(RefType type, PrintStream stream) {
		stream.append(REF);
		stream.append(type2id.get(type).toString()); stream.append(END);
		stream.append(type.qualifedClassName); stream.append(END);
		stream.append(END);
		
	}
}
	
