package br.usp.ime.mac499.xba.util;

import java.util.HashMap;
import java.util.Map;
import java.util.Stack;

/**
 * Uma tabela de símbolos com escopos
 * TODO: Fazer uma implementação mais eficiente do que stack de hashes.
 * @author stagni
 *
 * @param <T> O que que a tabela de símbolos guarda?
 */
public class BindingsManager<T> {
	Stack<Scope<T>> scopes;
	
	public BindingsManager() {
		scopes = new Stack<Scope<T>>();
	}
	
	public Scope<T> addNewScope() {
		return scopes.push(new Scope<T>());
	}
	
	public void exitCurrScope() {
		scopes.pop();
	}
	
	public void addBinding(String key, T binded) {
		scopes.peek().bindings.put(key, binded);
	}
	
	public T lookup(String key) {
		for (int k = scopes.size() - 1; k >= 0; k--) {
			if (scopes.get(k).bindings.containsKey(key))
				return scopes.get(k).bindings.get(key);
		}
		return null;
	}
	
	public static class Scope<T> {
		private Map<String, T> bindings;
		Scope() {
			bindings = new HashMap<String, T>();
		}
	}
	
}
