package br.usp.ime.mac499.other;

import static org.objectweb.asm.Opcodes.ACC_PUBLIC;
import static org.objectweb.asm.Opcodes.ACC_STATIC;
import static org.objectweb.asm.Opcodes.ALOAD;
import static org.objectweb.asm.Opcodes.DUP;
import static org.objectweb.asm.Opcodes.H_INVOKESTATIC;
import static org.objectweb.asm.Opcodes.INVOKESPECIAL;
import static org.objectweb.asm.Opcodes.NEW;
import static org.objectweb.asm.Opcodes.RETURN;
import static org.objectweb.asm.Opcodes.V1_7;

import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;

import org.junit.Test;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.Handle;
import org.objectweb.asm.MethodVisitor;

import br.usp.ime.mac499.xba.runtime.XBAObject;


public class InvDynTest {
	@Test
	public void gen() throws IOException {
		
		ClassWriter cw = new ClassWriter(ClassWriter.COMPUTE_MAXS);
		cw.visit(V1_7, ACC_PUBLIC, "br/usp/ime/mac499/xba/runtime/TestClass", null, "java/lang/Object", null);
		MethodVisitor mvCons = cw.visitMethod(ACC_PUBLIC, "<init>", "()V", null, null);
		mvCons.visitCode();
		mvCons.visitVarInsn(ALOAD, 0);
		mvCons.visitMethodInsn(INVOKESPECIAL, "java/lang/Object", "<init>", "()V");
		mvCons.visitInsn(RETURN);
		mvCons.visitMaxs(1, 1);
		mvCons.visitEnd();
		MethodVisitor mv = cw.visitMethod(ACC_PUBLIC + ACC_STATIC, "main", "([Ljava/lang/String;)V", null, null);
		mv.visitTypeInsn(NEW, "br/usp/ime/mac499/xba/runtime/XBAObject");
		mv.visitInsn(DUP);
		mv.visitInsn(DUP);
		mv.visitMethodInsn(INVOKESPECIAL, "br/usp/ime/mac499/xba/runtime/XBAObject", "<init>", "()V");
		//mv.visitMethodInsn(INVOKEVIRTUAL, "ClasseA", "metodo1", "()V");
		
		
		Handle bootstrap = new Handle(H_INVOKESTATIC, "br/usp/ime/mac499/xba/runtime/XBACallSite",
				"bootstrap", "(Ljava/lang/invoke/MethodHandles$Lookup;Ljava/lang/String;Ljava/lang/invoke/MethodType;)Ljava/lang/invoke/CallSite;");
		
		mv.visitInvokeDynamicInsn("foo", XBAObject.rraRawType.toMethodDescriptorString(), bootstrap);
		
		mv.visitInsn(RETURN);
		mv.visitMaxs(-1, -1);
		mv.visitEnd();
		cw.visitEnd();
		byte[] classBytes = cw.toByteArray();
		URL url = this.getClass().getClassLoader().getResource("");
		String out = url.getPath() + "/br/usp/ime/mac499/xba/runtime/TestClass.class";

		FileOutputStream fos = new FileOutputStream(out);
		fos.write(classBytes);
		fos.close();
	}
}
