package br.usp.ime.mac499.xba.codegen;

import java.io.File;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URL;

import org.junit.Test;

import br.usp.ime.mac499.xba.parser.ParseException;

/**
 * Gera arquivos .class compilados a partir de programas exemplos.
 * Para executá-los vá na pasta de saída e digite
 * java br.usp.ime.mac499.xba.runtime.Launcher NOME_DO_PROGRAMA_GERADO
 * 
 * @author stagni
 *
 */
public class CodeGenTest {

	@Test
    public void generateCode() throws ParseException, IOException {
    	XBAClassCompiler compiler = new XBAClassCompiler();
    	compiler.compile("progs/incomplete/class/simple-class", "/tmp/Simple.class");    	
    }
	
	@Test
    public void generateCodeHello() throws ParseException, IOException {
    	XBAClassCompiler compiler = new XBAClassCompiler();
    	compiler.compile("progs/complete/hello", binPath + "/Hello.class");    	
    }
	
	@Test
    public void generateCodeMdc() throws ParseException, IOException {
    	XBAClassCompiler compiler = new XBAClassCompiler();
    	compiler.compile("progs/complete/mdc", binPath + "/Mdc.class");    	
    }
	
	@Test
    public void generateCodeVector() throws ParseException, IOException {
    	XBAClassCompiler compiler = new XBAClassCompiler();
    	compiler.compile("progs/complete/vector", binPath + "/Vector.class");    	
    }
	
	@Test
    public void generateCodeTestMdc() throws ParseException, IOException {
    	XBAClassCompiler compiler = new XBAClassCompiler();
    	compiler.compile("progs/complete/testmdc", binPath + "/TestMdc.class");    	
    }
	
	@Test
    public void generateCodeTestVector() throws ParseException, IOException {
    	XBAClassCompiler compiler = new XBAClassCompiler();
    	compiler.compile("progs/complete/testvector", binPath + "/TestVector.class");    	
    }
	
	@Test
    public void generateCodeTestBigger() throws ParseException, IOException {
    	XBAClassCompiler compiler = new XBAClassCompiler();
    	compiler.compile("progs/complete/testbigger", binPath + "/TestBigger.class");    	
    }
	
	private static String binPath;
	static {
		ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
		URL url = classLoader.getResource("");
		try {
			File file = new File(url.toURI());
			binPath = file.toString();
		} catch (URISyntaxException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	
}
