package br.usp.ime.mac499.xba.types.inference;

import static org.junit.Assert.assertTrue;

import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;

import org.junit.Test;

import br.usp.ime.mac499.xba.ast.ASTClass;
import br.usp.ime.mac499.xba.ast.ASTModule;
import br.usp.ime.mac499.xba.ast.Node;
import br.usp.ime.mac499.xba.parser.ParseException;
import br.usp.ime.mac499.xba.parser.XBAFullParser;

public class TypeCheckerTest {
	
	@Test
	public void testSimpleClass() throws UnsupportedEncodingException, FileNotFoundException, ParseException {
		XBAFullParser parser = new XBAFullParser("progs/incomplete/class/simple-class");
		Node node = parser.XBAClass();
		assertTrue(node instanceof ASTModule);
		ASTClass c = (ASTClass) node.jjtGetChild(0);
		TypeChecker tc = new TypeChecker();
		System.out.println(TypePrinter.print(tc.typecheck(c)));
	}
	
	@Test
	public void testRecursiveClass() throws UnsupportedEncodingException, FileNotFoundException, ParseException {
		XBAFullParser parser = new XBAFullParser("progs/incomplete/class/recursive-class");
		Node node = parser.XBAClass();
		assertTrue(node instanceof ASTModule);
		ASTClass c = (ASTClass) node.jjtGetChild(0);
		TypeChecker tc = new TypeChecker();
		System.out.println(TypePrinter.print(tc.typecheck(c)));
	}
	
	@Test
	public void testSimpleClass2() throws UnsupportedEncodingException, FileNotFoundException, ParseException {
		
		XBAFullParser parser = new XBAFullParser("progs/incomplete/class/simple-class-with-members-only");
		Node node = parser.XBAClass();
		assertTrue(node instanceof ASTModule);
		ASTClass c = (ASTClass) node.jjtGetChild(0);
		TypeChecker tc = new TypeChecker();
		System.out.println(TypePrinter.print(tc.typecheck(c)));
	}
	
	
}
